﻿class EquationGrapherWithGrid extends EquationGrapher {
	function EquationGrapherWithGrid() {
	}
	var gridDrawer;
	function makeGrid(max, min) {
		var a = max;
		var b = min;
		var c = a-b;
		var exp = Math.floor(Math.log(c)/Math.LN10);
		var unit = Math.pow(10, exp);
		var testUnit = [unit/5, unit/2, unit, unit*2, unit*5];
		for (var k = 0; k<testUnit.length; k++) {
			var tUnit = testUnit[k];
			var af = Math.floor(a/tUnit);
			var bf = Math.ceil(b/tUnit);
			var gridLineNumber = (af-bf)+1;
			if (gridLineNumber<6) {
				break;
			}
		}
		unit = tUnit;
		//trace("after modify, get "+g+" lines to draw and the unit is "+unit);
		var gridArr = [];
		var y = unit*Math.ceil(b/unit);
		//############## here is the problem, the unit changed ?)
		//add a debug to stop the infinite loop if anything go wrong
		var debug = 0;
		while (y<=a && debug<100) {
			debug++;
			gridArr.push(y);
			y += unit;
		}
		trace("max min="+b+","+a);
		trace(gridArr);
		return gridArr;
	}
	//################################
	function drawGrid() {
		gridDrawer = createEmptyMovieClip("gridDrawer", 100);
		gridDrawer.lineStyle(1, 0xdddddd);
		//clean previous one
		trace(" mak Y");
		var yGrid = makeGrid(yMax, yMin);
		trace("make X");
		var xGrid = makeGrid(xMax, xMin);
		var index = 2;
		for (var k = 0; k<yGrid.length; k++) {
			//create Text
			var gy = yGrid[k];
			var pt = graphToLocal(0, gy);
			gridDrawer.moveTo(0, pt.y);
			gridDrawer.lineTo(canvasW, pt.y);
			gridDrawer.createTextField("txt"+index, index++, 0, pt.y, 100, 16);
			gridDrawer["txt"+index].text = String(gy);
			gridDrawer["txt"+index].autoSize = true;
			gridDrawer["txt"+index]._x = -gridDrawer["txt"+index]._width;
			gridDrawer["txt"+index]._y -= gridDrawer["txt"+index]._height/2;
			gridDrawer["txt"+index].selectable = false;
			//text should round the number
		}
		for (var k = 0; k<xGrid.length; k++) {
			//create Text
			var gx = xGrid[k];
			var pt = graphToLocal(gx, 0);
			gridDrawer.moveTo(pt.x, 0);
			gridDrawer.lineTo(pt.x, -canvasH);
			gridDrawer.createTextField("txt"+index, index++, pt.x, 0, 100, 16);
			gridDrawer["txt"+index].text = String(gx);
			gridDrawer["txt"+index].autoSize = true;
			gridDrawer["txt"+index].selectable = false;
			gridDrawer["txt"+index]._x -= gridDrawer["txt"+index]._width/2;
		}
	}
	function render() {
		super.render();
		drawGrid();
	}
}
